/*****************************************************************************
 *          DigASM: a minimal assembler for educational purpose              *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2010 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __CODE_GENERATION_H
#define __CODE_GENERATION_H

#define MAX_INSTRUCTIONS 8*1024

void emit_add(unsigned short int r_target, 
	      unsigned short int r1, 
	      unsigned short int r2);

void emit_sub(unsigned short int r_target, 
	      unsigned short int r1, 
	      unsigned short int r2);

void emit_ldi(unsigned short int r_target, 
	      unsigned short int value);

void emit_ldi_label_lo(unsigned short int r_target, char* label);

void emit_ldi_label_hi(unsigned short int r_target, char* label);

void emit_ldi(unsigned short int r_target, 
	      unsigned short int value);

void emit_ld(unsigned short int r_target, 
	     unsigned short int r_base, 
	     unsigned short int offset);

void emit_ld_neg (unsigned short int r_target, 
		  unsigned short int r_base, 
		  unsigned short int offset);

void emit_st(unsigned short int r_source, 
	     unsigned short int r_base, 
	     unsigned short int offset);

void emit_st_neg(unsigned short int r_source, 
		 unsigned short int r_base, 
		 unsigned short int offset);

void emit_beq(unsigned short int r1, 
	      unsigned short int r2, char* label);

void emit_ja(unsigned short int r1, 
	     unsigned short int r2);

void emit_j(char* label);

void emit_data_num1(unsigned short int value); //value1 = 0
void emit_data_num2(unsigned short int value0, unsigned short int value1);
void emit_data_string(char* s); //Ecrivent un nombre *pair* d'octets

void define_label(char* label);

void fix_labels();

void emit_code(char* file_name);

#endif
